<template>
  <div class=".cruds__edit">
      <h1> Nova {{ getMode }} </h1>

      <div v-show="getMode === 'trilha'">
        <h2> Trilhas </h2>

        <div> Codigo: <input type="text" v-model="trl_codigo"> </div>
        <div> Nome: <input type="text" v-model="trl_nome"> </div>
        <div> Descricao: <input type="text" v-model="trl_descricao"> </div>
        <div> Minimo de Disciplinas: <input type="integer" v-model="trl_mindscp"> </div>
        <div> Minimo de Modulos: <input type="integer" v-model="trl_minmod"> </div>

        <button type="submit" @click="new_track"> salvar </button>
      </div>


      <div v-show="$store.getters.getMode === 'modulo'">
        <h2> Módulos </h2>

        <div> Codigo: <input type="text" v-model="mod_codigo"> </div>
        <div> Minimo de Disciplinas: <input type="integer" v-model="mod_mindscp"> </div>
        <div> Codigo da Trilha: <input type="integer" v-model="mod_trl_cdg"> </div>

        <button type="submit" @click="new_module"> salvar </button>
      </div>

      <div v-show="$store.getters.getMode === 'optativa'"
         class=".cruds__edit__optativas">
          <h2> Optativas compõem módulos </h2>

          <div> Codigo da Disciplina: <input type="text" v-model="opt_cod_dscp"> </div>
          <div> Ano Grade: <input type="integer" v-model="opt_ano"> </div>
          <div> Codigo do Módulo: <input type="integer" v-model="opt_cod_mod"> </div>

          <button type="submit" @click="new_optional"> salvar </button>
        </div>

        <router-link rag="div" to="/trilhas"> &larr; </router-link>
  </div>
</template>

<script>
import {mapGetters} from 'vuex';

export default {
  data() {
    return {
      trl_codigo: null,
      trl_nome: null,
      trl_descricao: null,
      trl_mindscp: null,
      trl_minmod: null,

      mod_codigo: null,
      mod_mindscp: null,
      mod_trl_cdg: null,

      opt_cod_dscp: null,
      opt_ano: null,
      opt_cod_mod: null
    }
  },

  methods: {
    async new_track() {
      const response = await this.$axios.$post('/rpc/insere_trilha', {
        nusp: this.getNusp,
        codigo_trilha: this.trl_codigo,
        descricao: this.trl_descricao,
        minimo_modulos: this.trl_minmod,
        minimo_disciplinas: this.trl_mindscp,
        nome: this.trl_nome
      },
      { headers: {Authorization: `Bearer ${this.getToken}`} }
      )

      if (response)
        this.$router.push('/trilhas');
    },

    async new_module() {
      const response = await this.$axios.$post('/rpc/insere_modulo', {
        nusp: this.getNusp,
        cdg_trilha: this.mod_trl_cdg,
        codigo_modulo: this.mod_codigo,
        minimo_disciplinas: this.mod_mindscp
      },
      { headers: {Authorization: `Bearer ${this.getToken}`} }
      )

      if (response)
        this.$router.push('/trilhas');
    },

    async new_optional() {
      const response = await this.$axios.$post('/rpc/insere_optativa_modulo', {
       nusp: this.getNusp,
       cdg_modulo: this.opt_cod_mod,
       cdg_disciplina: this.opt_cod_dscp,
       ano_grade_optativa: this.opt_ano,
      },
      { headers: {Authorization: `Bearer ${this.getToken}`} }
      )

      if (response)
        this.$router.push('/trilhas');
    }
  },

  computed: {
    ...mapGetters([
      'getNusp',
      'getToken',
      'getActiveTrilha',
      'getActiveModulo',
      'getActiveOptativa',
      'getMode'
    ])
  }
}
</script>

<style lang="scss">
.cruds__edit {
}
</style>

